// +------------------------------------------------------------------+
// |                                                         Solo 1.5 |
// |                                                          2007   |
// |                Modified by Avalonish                             |
// |                            Davidke20 -> Magic Number             |
// |                            Kaper -> Money Management             |
// +------------------------------------------------------------------+
// |                                                                  |
// |   MQ's Standard MACD EA with a bit more control given to user..  |
// |            Works great with GBPUSD H4 TF                         |
// +------------------------------------------------------------------+

extern string EA= "Solo 1.5";
extern bool MoneyManagement = false;
extern int RiskFactor = 2.0;
extern double Slippage = 3;
extern double Lots = 0.1;
extern double Profit = 120.0;
extern double Stop = 100.0;
extern double TrailingStop = 25.0;
extern bool UseRSIFilter=true;
extern int F_ma = 28;
extern int S_ma = 62;
extern int Signal= 18;
extern double MACDOpenLevel=3;
extern double MACDCloseLevel=2;
extern double MATrendPeriod=13;
extern string MAMode= "0=sma, 1=ema, 2=smma, 3=lwma";
extern int MA_Mode = 1; // MA method.
extern string MAPrice= "0=close, 1=open, 2=high, 3=low, 4=median, 5=typical, 6=weightedclose";
extern int MA_Price  = 0; // Applied price.

int MagicNumber = 0;
double LotSize, MinLot, LotStep;

int init()
  {
   LotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
   MinLot = MarketInfo(Symbol(), MODE_MINLOT);
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   if (Symbol()=="AUDCADm" || Symbol()=="AUDCAD") {MagicNumber=100001;}
   if (Symbol()=="AUDJPYm" || Symbol()=="AUDJPY") {MagicNumber=100002;}
   if (Symbol()=="AUDNZDm" || Symbol()=="AUDNZD") {MagicNumber=100003;}
   if (Symbol()=="AUDUSDm" || Symbol()=="AUDUSD") {MagicNumber=100004;}
   if (Symbol()=="CHFJPYm" || Symbol()=="CHFJPY") {MagicNumber=100005;}
   if (Symbol()=="EURAUDm" || Symbol()=="EURAUD") {MagicNumber=100006;}
   if (Symbol()=="EURCADm" || Symbol()=="EURCAD") {MagicNumber=100007;}
   if (Symbol()=="EURCHFm" || Symbol()=="EURCHF") {MagicNumber=100008;}
   if (Symbol()=="EURGBPm" || Symbol()=="EURGBP") {MagicNumber=100009;}
   if (Symbol()=="EURJPYm" || Symbol()=="EURJPY") {MagicNumber=100010;}
   if (Symbol()=="EURUSDm" || Symbol()=="EURUSD") {MagicNumber=100011;}
   if (Symbol()=="GBPCHFm" || Symbol()=="GBPCHF") {MagicNumber=100012;}   
   if (Symbol()=="GBPJPYm" || Symbol()=="GBPJPY") {MagicNumber=100013;}
   if (Symbol()=="GBPUSDm" || Symbol()=="GBPUSD") {MagicNumber=100014;}
   if (Symbol()=="NZDJPYm" || Symbol()=="NZDJPY") {MagicNumber=100015;}
   if (Symbol()=="NZDUSDm" || Symbol()=="NZDUSD") {MagicNumber=100016;}
   if (Symbol()=="USDCHFm" || Symbol()=="USDCHF") {MagicNumber=100017;}
   if (Symbol()=="USDJPYm" || Symbol()=="USDJPY") {MagicNumber=100018;}
   if (Symbol()=="USDCADm" || Symbol()=="USDCAD") {MagicNumber=100019;}
   if (MagicNumber==0) {MagicNumber = 100999;} // Auto Magic #: Learned from Mcarty3 EA by Aaragorn (http://www.forex-tsd.com/members/aaragorn.html)

   return(0);
  }

int deinit()
  {
//---- 
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Money Management for lot size                                    |
//+------------------------------------------------------------------+
double lot_size()
  {
   double lots;
   if (!MoneyManagement)
      return (Lots);
   lots = (AccountFreeMargin()* AccountLeverage() / LotSize) * RiskFactor/100.0;
   if (lots < MinLot) lots = MinLot;
   lots /= LotStep;
   lots = NormalizeDouble(lots, 0);
   lots *= LotStep;
   return(lots);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double StopLoss, TakeProfit, up, down;
    
   int cnt, total, ticket;
   total=OrdersTotal();

   double MacdCurrent=iMACD(NULL,0,F_ma,S_ma,Signal,PRICE_CLOSE,MODE_MAIN,0);
   double MacdPrevious=iMACD(NULL,0,F_ma,S_ma,Signal,PRICE_CLOSE,MODE_MAIN,1);
   double SignalCurrent=iMACD(NULL,0,F_ma,S_ma,Signal,PRICE_CLOSE,MODE_SIGNAL,0);
   double SignalPrevious=iMACD(NULL,0,F_ma,S_ma,Signal,PRICE_CLOSE,MODE_SIGNAL,1);
   double MaCurrent=iMA(NULL,0,MATrendPeriod,0,MA_Mode,MA_Price,0);
   double MaPrevious=iMA(NULL,0,MATrendPeriod,0,MA_Mode,MA_Price,1);
   double MyRSI=iRSI(NULL,0,14,PRICE_CLOSE,1);

   for(cnt = 0; cnt < total; cnt++) 
     {
   if(UseRSIFilter){up=50;down=50;}else{up=100;down=0;}
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if (OrderMagicNumber() ==MagicNumber) // recommendation to add magic # statement here by Davidke20
     {

   if(OrderType() == OP_BUY) 
     {
       if(MacdCurrent>0 && MacdCurrent<SignalCurrent && 
          MacdPrevious>SignalPrevious && MathAbs(MacdCurrent)>(MACDCloseLevel*Point) && MyRSI<up)
     {
      OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); // close position
      return(0); // exit
     }
       if((TrailingStop > 0) &&
         (Bid - OrderOpenPrice() > TrailingStop*Point) &&
         (OrderStopLoss() < (Bid - TrailingStop*Point)))

      OrderModify(OrderTicket(), OrderOpenPrice(), 
      Bid - TrailingStop*Point, OrderTakeProfit(), 0, Blue);
      return(0);
     }

   if(OrderType() == OP_SELL)
     {
       if(MacdCurrent<0 && MacdCurrent>SignalCurrent &&
          MacdPrevious<SignalPrevious && MathAbs(MacdCurrent)>(MACDCloseLevel*Point) && MyRSI>down)
     {
      OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); // close position
      return(0); // exit
     }
       if((TrailingStop > 0) &&
         (OrderOpenPrice() - Ask > TrailingStop*Point) &&
         (OrderStopLoss() == 0 || OrderStopLoss() > (Ask + TrailingStop*Point)))

      OrderModify(OrderTicket(), OrderOpenPrice(), 
      Ask + TrailingStop*Point, OrderTakeProfit(), 0, Red);
      return(0);
     }
    }
   }
// Executing a Long Position
 if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious &&
    MathAbs(MacdCurrent)>(MACDOpenLevel*Point) && MaCurrent>MaPrevious)
   {
    if (Stop != 0) StopLoss = Bid - Stop * Point;
    if (Profit != 0) TakeProfit = Ask+Profit*Point;

      ticket=OrderSend(Symbol(),OP_BUY,lot_size(),Ask,Slippage,StopLoss,TakeProfit,"Solo 1.5",MagicNumber,0,Green);
      if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
   }
      else Print("Error opening BUY order : ",GetLastError()); 
      return(0);
   }

// Executing a Short Position
 if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious && 
    MacdCurrent>(MACDOpenLevel*Point) && MaCurrent<MaPrevious)
   {  
    if (Stop != 0) StopLoss = Ask + Stop * Point;
    if (Profit != 0) TakeProfit = Bid-Profit*Point;

      OrderSend(Symbol(),OP_SELL,lot_size(),Bid,Slippage,StopLoss,TakeProfit,"Solo 1.5",MagicNumber,0,Red);
    if(ticket>0)
   {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
   }
    else Print("Error opening SELL order : ",GetLastError()); 
    return(0);
   }
 }